Name: SysVinit
Version: 2.85
Release: alt6

Summary: Programs which control basic system processes
License: GPL
Group: System/Configuration/Boot and Init
Url: ftp://ftp.cistron.nl/pub/people/miquels/sysvinit

Source: %url/sysvinit-%version.tar.bz2

%def_without ssd

# CVS/DEB

# ALT/OW
Patch21: sysvinit-2.85-owl-wall-longjmp-clobbering.patch
Patch22: sysvinit-2.85-owl-format.patch
Patch23: sysvinit-2.85-alt-progname-umask.patch
Patch24: sysvinit-2.85-alt-owl-start-stop-daemon.patch
Patch25: sysvinit-2.85-alt-owl-bootlogd.patch
Patch26: sysvinit-2.85-owl-mount-proc.patch
Patch27: sysvinit-2.85-owl-typos.patch
Patch28: sysvinit-2.85-rh-alt-pidof.patch
Patch29: sysvinit-2.85-rh-alt-owl-shutdown-log.patch
Patch30: sysvinit-2.85-owl-alt-makefile.patch
Patch31: sysvinit-2.85-alt-doc.patch

# rest
Patch41: sysvinit-2.85-rh-alt-lasttime.patch
Patch42: sysvinit-2.85-unknown-alt-last-ws.patch

PreReq: coreutils
Requires: /sbin/sulogin
%if_with ssd
Provides: /sbin/start-stop-daemon
%endif
Conflicts: glibc < 6:2.2.1-ipl0.2mdk, 
BuildConflicts: openssl-devel < 0.9.6a

%description
The SysVinit package contains a group of programs that control the
very basic functions of your system.  SysVinit includes the init
program, the first program started by the Linux kernel when the
system boots.  init then controls the startup, running and shutdown
of all other programs.

%prep
%setup -q -n sysvinit-%version

# CVS/DEB

%__rm -f man/sulogin.8

# ALT/OW
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1

# rest
%patch41 -p1
%patch42 -p1

pushd src
find -type f -print0 |
	xargs -r0 %__grep -FZl '"paths.h"' -- |
	xargs -r0 %__subst 's/"paths\.h"/"paths_init.h"/g' --
mv paths.h paths_init.h
echo '#include <paths.h>' >>paths_init.h
popd

find -type f -name \*.orig -print -delete

%build
%add_optflags -Werror
%make_build -C src all \
	LCRYPT=-lcrypt \
	LDFLAGS= \
	#
%make_build -C src bootlogd \
	LCRYPT= \
	LDFLAGS=-lutil \
	#
%if_with ssd
pushd contrib
	gcc start-stop-daemon.c $RPM_OPT_FLAGS -D_GNU_SOURCE -o start-stop-daemon
popd
%endif

%install
%__mkdir_p $RPM_BUILD_ROOT{/{s,}bin,/dev,%_bindir,%_includedir,%_mandir/man{1,3,5,8}}
%make_install install -C src \
	ROOT=$RPM_BUILD_ROOT \
	#

%__install -p -m755 src/bootlogd $RPM_BUILD_ROOT/sbin/
%if_with ssd
%__install -p -m755 contrib/start-stop-daemon $RPM_BUILD_ROOT/sbin/
%endif

mkfifo -m600 $RPM_BUILD_ROOT/dev/initctl

%pre
# This is tricky.  We don't want to let RPM remove the only link to the
# old init as that would actually leave it pending for delete on process
# termination.  That delete is a filesystem write operation meaning that
# the root filesystem would need to stay mounted read/write.  But we
# absolutely want to be able to remount it read-only during shutdown,
# possibly with the old init still alive!
if [ -e /sbin/init -a ! -e /sbin/.init-working ]; then
	/bin/ln /sbin/init /sbin/.init-working
fi

%post
# If /proc is mounted and /sbin/.init-working is running, tell init to
# invoke the replaced version of itself.
if /sbin/pidof /sbin/.init-working >/dev/null 2>&1; then
	/sbin/telinit u
	sleep 1
fi

# If /proc is not mounted or /sbin/.init-working is no longer running,
# remove it.
if ! /sbin/pidof /sbin/.init-working >/dev/null 2>&1; then
	/bin/rm -f /sbin/.init-working
fi

%files
%defattr(700,root,root)
/sbin/init
/sbin/shutdown
/sbin/bootlogd

%defattr(-,root,root,-)
/sbin/halt
/sbin/poweroff
/sbin/reboot
/sbin/telinit
/sbin/killall5
/sbin/pidof
/sbin/runlevel
%if_with ssd
/sbin/start-stop-daemon
%endif

/bin/pidof
%_bindir/last
%_bindir/lastb
%_bindir/mesg
%attr(2711,root,tty) %_bindir/wall

%_includedir/*

%ghost /dev/initctl

%_mandir/man?/*
%doc README contrib/TODO
%doc doc/{Propaganda,Install,sysvinit-%version.lsm,bootlogd.README}
%if_with ssd
%doc contrib/start-stop-daemon.README
%endif

%changelog
* Wed Aug 20 2003 Dmitry V. Levin <ldv@altlinux.org> 2.85-alt6
- Fixed build.
- Build with -Werror.
- Fixed annoying 'must be superuser' error messages.

* Mon May 12 2003 Dmitry V. Levin <ldv@altlinux.org> 2.85-alt5
- Removed rh-alt-halt patch,
  install startup >= 0.1-alt1 package is recommended.
- Do not package start-stop-daemon by default,
  moved to service >= 0.1-alt1 package.

* Tue May 06 2003 Dmitry V. Levin <ldv@altlinux.org> 2.85-alt4
- PreReq: coreutils (#0002562).

* Sun Apr 27 2003 Dmitry V. Levin <ldv@altlinux.org> 2.85-alt3
- Synced with 2.85-owl4:
  + Don't build sulogin, use new implementation from msulogin package.
  + Don't mount /proc in pidof, and mount it as "proc" rather than "none"
    in killall5 such that umount and others can reasonably refer to it in
    error messages.
- Do not package utmpdump.

* Wed Apr 23 2003 Dmitry V. Levin <ldv@altlinux.org> 2.85-alt2
- Synced with 2.85-owl1:
  + New/updated patches:
    owl-wall-longjmp-clobbering
    owl-format
    owl-alt-sulogin
    alt-owl-start-stop-daemon
    alt-owl-bootlogd
    owl-mount-path
    owl-typos
    rh-alt-owl-shutdown-log

* Sun Apr 20 2003 Dmitry V. Levin <ldv@altlinux.org> 2.85-alt1
- Updated to 2.85.
  + Following patches are merged upstream:
    alt-wall-alarm
    alt-init-spawn
    alt-sulogin-notty
    rh-alt-wait
    owl-alt-bound
    owl-alt-format
    alt-wall-tty
    alt-man-wall
  + Updated patches:
    owl-alt-sulogin
- /sbin/start-stop-daemon:
  + various safety fixes;
  + changed pid_is_exec check.
- Provides: /sbin/start-stop-daemon.

* Tue Apr 15 2003 Dmitry V. Levin <ldv@altlinux.org> 2.84-alt8
- Reworked patches: following patches are going upstream:
  alt-wall-alarm
  alt-init-spawn
  alt-sulogin-notty
  rh-alt-wait
  owl-alt-bound
  owl-alt-format
  alt-wall-tty
  alt-man-wall

* Fri Apr 04 2003 Dmitry V. Levin <ldv@altlinux.org> 2.84-alt7
- Updated to 2.84-3.
- wall: fixed alarm handling (#0002460).

* Sat Mar 01 2003 Dmitry V. Levin <ldv@altlinux.org> 2.84-alt6
- Fixed build in system without /dev/initctl available.
- pidof: honor full pathname.
- wall: avoid writing to non-tty devices.
- last: added '-t' option for checking state at certain times (rh).
- shutdown: added logging on shutdown/reboot (rh).
- shutdown: spawn: fixed child process handling and program execution (rh).

* Tue Dec 10 2002 Dmitry V. Levin <ldv@altlinux.org> 2.84-alt5
- src/init.c(spawn): fixed bug reported by Vladimir N. Oleynik.
- Packaged /sbin/bootlogd and /sbin/start-stop-daemon.

* Tue Sep 17 2002 Dmitry V. Levin <ldv@altlinux.org> 2.84-alt4
- Revert back /sbin/halt permissions (to reenable -usermode).
- Use subst instead of perl in build scripts.

* Tue Aug 06 2002 Dmitry V. Levin <ldv@altlinux.org> 2.84-alt3
- Marked /dev/initctl socket as %%ghost (#0001125).

* Sat Jul 13 2002 Dmitry V. Levin <ldv@altlinux.org> 2.84-alt2
- Reviewed patches, dropped obsolete ones.
- Added building of bootlogd and start-stop-daemon.
- Restricted permissions on root-only programs.

* Thu Feb 28 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.84-alt1
- 2.84
- Added initreq.h

* Wed Nov 14 2001 Dmitry V. Levin <ldv@alt-linux.org> 2.83-alt1
- 2.83
- Moved usermode stuff to separate package.

* Tue Sep 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.82-alt2
- usermode: fixed pam config.

* Wed Aug 29 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.82-alt1
- 2.82

* Mon Aug 27 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.81-alt2
- Fixed version display info.
- Changed usermode subpackage requirements.

* Wed Aug 22 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.81-alt1
- 2.81
- Added usermode subpackage with consolehelpr bindings.

* Fri Jun 01 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.78-ipl5mdk
- Progname patch.
- Various bound and format checks from Owl project.
- Ensure the umask is no less restrictive than 022 (owl).
- Use getpass(3) in sulogin - the old code was unreliable (owl).

* Tue May 29 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.78-ipl4mdk
- Fixed umask (rh).

* Fri Feb 09 2001 Dmitry V. Levin <ldv@fandra.org> 2.78-ipl3mdk
- Merged RH patches:
  + document '-n' option to wall, make it root-only (rh).
  + don't open files in sulogin unless they're really ttys (rh).

* Wed Jan 10 2001 Dmitry V. Levin <ldv@fandra.org> 2.78-ipl2mdk
- Added blowfish crypt support (from libcrypt).

* Wed Oct 18 2000 Dmitry V. Levin <ldv@fandra.org> 2.78-ipl1mdk
- Merged MDK, RH and BCL patches.
- Re-execute /sbin/init in %post.

* Sun Feb 20 2000 Dmitry V. Levin <ldv@fandra.org>
- Fandra adaptions

* Wed Jan  5 2000 Dmitry V. Levin <ldv@fandra.org>
- Merge with mdk

* Fri Oct 22 1999 Dmitry V. Levin <ldv@fandra.org>
- Fandra adaptions

* Tue Oct 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Merge with redhat changes.

* Tue Sep 28 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- nologin patch isn't needed

* Tue Sep 14 1999 Daouda LO <daouda@mandrakesoft.com>
- 2.77

* Wed May 19 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- We can't hardlink /bin/pidof anywhere, because it's a symlink itself.
  Fix...

* Tue May 18 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Linking /bin/pidof to /sbin/pidof for RH compatibilities.

* Mon Apr 12 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- The normal source doen't work, we need to remove the orphan link to rebuild.

* Fri Apr  9 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- update to 2.76
- bzip2 man pages
- handle RPM_OPT_FLAGS
- remove some RH patches because they're not required with 2.76
- add de, fr, tr locales
- Move pidof from /sbin to /bin - can't hurt.

* Wed Jan 06 1999 Cristian Gafton <gafton@redhat.com>
- glibc 2.1

* Sun Aug 23 1998 Jeff Johnson <jbj@redhat.com>
- poweroff symlink not included (problem #762)

* Thu Jul 09 1998 Chris Evans <chris@ferret.lmh.ox.ac.uk>
- Fix a securelevel releated security hole. Go on, try and break append
  only files + securelevel now ;-)

* Wed Jul  8 1998 Jeff Johnson <jbj@redhat.com>
- remove /etc/nologin at end of shutdown.
- compile around missing SIGPWR on sparc

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Apr 08 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 2.74
- fixed the package source url... (yeah, it was wrong !)

* Wed Oct 1 1997 Cristian Gafton <gafton@redhat.com>
- fixed the MD5 check in sulogin (128 hash bits encoded with base64 gives
  22 bytes, not 24...). Fix in -md5.patch

* Thu Sep 11 1997 Christian 'Dr. Disk' Hechelmann <drdisk@ds9.au.s.shuttle.de>
- /etc/initrunlvl gets linked to /tmp/init-root/var/run/initrunlvl which is
  just plain wrong..
- /usr/bin/utmpdump was missing in the files section, although it was
  explicitly patched into PROGS.
- added attr's to the files section.
- various small fixes.

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- updated to 2.71
- built against glibc 2.0.4

* Fri Feb 07 1997 Michael K. Johnson <johnsonm@redhat.com>
- Added sulogin.8 man page to file list.
